; kunt0r's GdiPlus example, modified for use as DLL

; http://www.masm32.com/board/index.php?topic=5210.msg38936#msg38936

include \masm32\include\masm32rt.inc
include \masm32\include\PNGlib.inc
includelib \masm32\lib\PNGlib.lib

; Exports: Bmp2Png, FreeGdiPlus

Bmp2Png	proto:DWORD		;usage: invoke Bmp2Png, addr bitmapfile
FreeGdiPlus	proto

initpng	proto

GdiplusStartup_proto	typedef	proto :dword, :dword, :dword
GdiplusStartup_proc	typedef	ptr GdiplusStartup_proto
GdiplusShutdown_proto	typedef	proto :dword
GdiplusShutdown_proc	typedef	ptr GdiplusShutdown_proto
GdipLoadImageFromFile_proto	typedef	proto :dword, :dword
GdipLoadImageFromFile_proc	typedef	ptr GdipLoadImageFromFile_proto
GdipSaveImageToFile_proto	typedef	proto :dword, :dword, :dword, :dword
GdipSaveImageToFile_proc	typedef	ptr GdipSaveImageToFile_proto
GdipGetImageEncodersSize_proto	typedef	proto :dword, :dword
GdipGetImageEncodersSize_proc	typedef	ptr GdipGetImageEncodersSize_proto
GdipGetImageEncoders_proto	typedef	proto :dword, :dword, :dword
GdipGetImageEncoders_proc	typedef	ptr GdipGetImageEncoders_proto
GdipDisposeImage_proto	typedef	proto :dword
GdipDisposeImage_proc	typedef	ptr GdipDisposeImage_proto

.data?
GdiplusStartupInput	struct
GdiplusVersion	dd ?
DebugEventCallback	dd ?
SuppressBackgroundThread	dd ?
SuppressExternalCodecs	dd ?
GdiplusStartupInput ends

GdiplusStartupOutput struct
NotificationHook	dd ?
NotificationUnhook	dd ?
GdiplusStartupOutput ends

ImageCodecInfo struct
Clsid	dd ?, ?, ?, ?
FormatID	dd ?, ?, ?, ?
CodecName	dd ?
DllName	dd ?
FormatDescription	dd ?
FilenameExtension	dd ?
MimeType	dd ?
Flags	dd ?
Version	dd ?
SigCount	dd ?
SigSize	dd ?
SigPattern	dd ?
SigMask	dd ?
ImageCodecInfo ends

GdiToken	dd ?
EncInfo	dd ?	; made global for VirtualAlloc
GdiPLUS	dd ?	; made global for error check
GdiplusStartup	GdiplusStartup_proc ?
GdiplusShutdown	GdiplusShutdown_proc ?
GdipLoadImageFromFile	GdipLoadImageFromFile_proc ?
GdipSaveImageToFile	GdipSaveImageToFile_proc ?
GdipGetImageEncodersSize	GdipGetImageEncodersSize_proc ?
GdipGetImageEncoders	GdipGetImageEncoders_proc ?
GdipDisposeImage	GdipDisposeImage_proc ?

GpSrc	BYTE 256 DUP(?)
GpDest	BYTE 256 DUP(?)

.data
.listall ; requires setting ML.EXE ... /Fl in makefile

; Bmp2Png file to load:
; errLoadFile db "error: could not load file",0
; errDecode   db "error: could not decode PNG",0
; errBitmap   db "error: could not create bitmap",0

gdiplus_dll	db "gdiplus.dll", 0
mime_type	dw 'i','m','a','g','e','/','p','n','g', 0	;UniCode
ptrCLSID	dd 987654321 ;magic

LGdiplusStartup	db "GdiplusStartup", 0
LGdiplusShutdown	db "GdiplusShutdown", 0
LGdipLoadImageFromFile	db "GdipLoadImageFromFile", 0
LGdipSaveImageToFile	db "GdipSaveImageToFile", 0
LGdipGetImageEncodersSize	db "GdipGetImageEncodersSize", 0
LGdipGetImageEncoders	db "GdipGetImageEncoders", 0
LGdipDisposeImage	db "GdipDisposeImage", 0

MsgRet	dd IDOK
AppName	db "MyApp:"	; NO "0" - filename follows!
	db 128 dup (0)	; buffer for command line & Static

.code

; *********************
DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
	.IF reason==DLL_PROCESS_ATTACH ; do NOT show a message here, it may be fatal...
	; ...
	.elseif reason==DLL_PROCESS_DETACH
	; ...
	.elseif reason==DLL_THREAD_ATTACH
	  ; invoke MessageBox,NULL,addr ThreadCreated,addr AppName,MB_OK
	.else       ; DLL_THREAD_DETACH
	  ; invoke MessageBox,NULL,addr ThreadDestroyed,addr AppName,MB_OK
	.ENDIF
	mov	eax,TRUE
	ret
DllEntry Endp

;#########################################################

initpng proc

local gdisi:GdiplusStartupInput
local gdiso:GdiplusStartupOutput
local encnum:dword
local encsize:dword

invoke LoadLibrary, addr gdiplus_dll

mov GdiPLUS, eax
.if eax==0	; GdiPlus.dll not found
  ret
.endif

invoke GetProcAddress, GdiPLUS, addr LGdiplusStartup
mov GdiplusStartup, eax
invoke GetProcAddress, GdiPLUS, addr LGdiplusShutdown
mov GdiplusShutdown, eax
invoke GetProcAddress, GdiPLUS, addr LGdipLoadImageFromFile
mov GdipLoadImageFromFile, eax
invoke GetProcAddress, GdiPLUS, addr LGdipSaveImageToFile
mov GdipSaveImageToFile, eax
invoke GetProcAddress, GdiPLUS, addr LGdipGetImageEncodersSize
mov GdipGetImageEncodersSize, eax
invoke GetProcAddress, GdiPLUS, addr LGdipGetImageEncoders
mov GdipGetImageEncoders, eax
invoke GetProcAddress, GdiPLUS, addr LGdipDisposeImage
mov GdipDisposeImage, eax
mov gdisi.GdiplusVersion, 1
and gdisi.DebugEventCallback, 0
and gdisi.SuppressBackgroundThread, 0
and gdisi.SuppressExternalCodecs, 0
invoke GdiplusStartup, addr GdiToken, addr gdisi, addr gdiso

; Get the available encode settings
invoke GdipGetImageEncodersSize, addr encnum, addr encsize ; num = encoders availble on the computer, size = total amount of memory needed to store them
invoke VirtualAlloc, 0, encsize, MEM_COMMIT, PAGE_READWRITE
mov EncInfo, eax
invoke GdipGetImageEncoders, encnum, encsize, EncInfo ; Fills the memory block with all the encoding info

; Loop through all the encoders until we find the one we want (e.g. image/png)
	push ebx
	mov ebx, EncInfo
NextMime:	mov eax, [ebx.ImageCodecInfo.MimeType]
	add ebx, sizeof ImageCodecInfo
	invoke lstrcmpW, eax, addr mime_type
	test eax, eax
	jz MimeOK
	dec encnum
	jnz NextMime

; mime type not found:
; push eax
; push ebx
; invoke MessageBoxW,NULL,addr mime_type,addr gdiplus_dll,MB_OK
; pop ebx
; pop eax

MimeOK:	sub ebx, sizeof ImageCodecInfo
	mov ptrCLSID, ebx	; store for later use
	pop ebx
	ret
initpng endp

;#########################################################
Bmp2Png proc SrcFile:DWORD
local pngimage:dword

.if ptrCLSID==987654321
	call initpng	; initialise
.endif
.if GdiPLUS
	push edi
	push esi
	mov edi,offset GpSrc	; Unicode bmp
	mov edx,offset GpDest	; Unicode png
	mov esi,SrcFile
	xor eax,eax		; clr higher bits
	
NotNull:	mov al,[esi]
	mov [edi],al
	mov [edx],al
	add edi,2
	add edx,2
	inc esi
	test eax,eax
	jnz NotNull

	sub edx,4		; put "png" into the last three bytes
	mov eax,'g'
	mov [edx],al
	sub edx,2
	mov eax,'n'
	mov [edx],al
	sub edx,2
	mov eax,'p'
	mov [edx],al

	invoke GdipLoadImageFromFile, addr GpSrc, addr pngimage	; Load the image from file
	invoke GdipSaveImageToFile, pngimage, addr GpDest, ptrCLSID, 0	; Save it
	invoke GdipDisposeImage, pngimage	; Clean up

	pop esi
	pop edi
.else
	xor eax,eax
	add eax,99	; error 99 = GdiPlus not found on this computer
.endif
ret

Bmp2Png endp

;#########################################################################
FreeGdiPlus proc
.if GdiPLUS
	invoke VirtualFree, EncInfo, 0, MEM_RELEASE
	invoke GdiplusShutdown, GdiToken
	mov ptrCLSID,987654321	; tell next call that init is needed
	invoke FreeLibrary,GdiPLUS
.endif
ret

FreeGdiPlus endp
End DllEntry
